$(function(){
  init();
});

let MasterNode = "-";

let appData = {
  master: "-",
  slaves: [],
  ips: [],
  slaves_selected: [],
  nc10393: []
}

let States = {
  recording: false,
  parsinit: false
};

let Cams = [];

async function a_init(){

  let res;

  // url
  res = await a_parse_url();
  parse_cmd_ifconfig_init(res);

  // detect
  res = await a_detect_10393s();
  parse_detect_10393s(res);

  // read params
  res = await a_read_params();
  parse_read_params(res);

  // update interface
  update_ui();
  console.log("Done");

}

function update_ui(){

  let pars = {
    color :      undefined,
    quality:     undefined,
    trig_period: undefined,
    wb_en:       undefined,
    autoexp_on:  undefined
  }

  for (let p in pars){
    for(let i=0;i<Cams.length;i++){
      for(let j=0;j<Cams[i].ports.length;j++){
        let tmp = Cams[i].ports[j].parameters[p];
        // init
        if (pars[p]===undefined){
          pars[p] = tmp;
        // this is an exclusion
        // TODO: fix and remove later
        }else if (pars[p]===1){
          pars[p] = tmp;
        // after init
        }else{
          // not all are "none"
          if (!Cams[i].ports[j].sensor.every(v => v === "none")){
            // comparing init to others
            if ((pars[p]!==tmp)&&(tmp!==1)){
              console.log("Warning! "+p+" is not the same across all cameras/ports");
            }
          }
        }
      }
    }
  }

  const format  = format_num2str(pars.color);
  const quality = pars.quality;
  const fps     = fps_period2fps(pars.trig_period);

  $("#set_format .input-par").val(format);
  $("#set_quality .input-par").val(quality);
  $("#set_fps .input-par").val(fps);

  button_switch($('#toggle_awb') , pars.wb_en);
  button_switch($('#toggle_aexp'), pars.autoexp_on);

}

function init(){

  // css
  $("#nodelist").css({
    padding:'10px 0px'
  });

  //$("#masternode").css({
  //  'font-weight': 'bold'
  //});

  update_master_node();

  // this one is async
  a_init().then(async () => {

    console.log("Tadam!");

  });

  init_controls();
  init_awb_toggle();
  init_aexp_toggle();

  // init button
  $('#listmasters').on('click', function(e){

    $.ajax({
      url: '/api/nodelist',
      success: function(response){

        const l = response.trim().split('\n');

        let ll = [];

        $("#nodelist").empty();
        l.forEach(function(entry) {
          ll.push("<div class='master_nodes'>"+entry+"</div>");
        });
        $("#nodelist").empty().append(ll.join('\n'));

        $(".master_nodes").on('click',function(e){

          update_master_node($(this).html());
          rewrite_url();

          // reset everything
          $("#nodelist").empty();
          $("#slavenodes").empty();
          appData.slaves = [];
          appData.ips = [];
          appData.slaves_selected = [];

          // go straight with ifconfig
          send_command('ifconfig', appData.slaves, parse_cmd_ifconfig_init);
        });

      }
    });

  });

  $('#testbutton2').on('click', function(e){
    send_command('state', appData.slaves_selected, parse_cmd_state);
  });

  // need a post request
  $('#testbutton3').on('click', function(e){

    // examples:
    //let cmd = "wget -qO- -o /dev/null 'http://localhost/parsedit.php?immediate&amp;TRIG'";
    //let cmd = "ifconfig";
    //let cmd = "wget -qO- -o /dev/null 'http://localhost/diagnostics.php'";
    //const cmd = "ifconfig";

    let path = "/sys/devices/soc0/elphel393-detect_sensors@0";
    let cmd = [
      'cd '+path,
      'cat port_mux0',
      'cat sensor00',
      'cat sensor01',
      'cat sensor02',
      'cat sensor03',
      'cat port_mux1',
      'cat sensor10',
      'cat sensor11',
      'cat sensor12',
      'cat sensor13',
      'cat port_mux2',
      'cat sensor20',
      'cat sensor21',
      'cat sensor22',
      'cat sensor23',
      'cat port_mux3',
      'cat sensor30',
      'cat sensor31',
      'cat sensor32',
      'cat sensor33'
    ].join(';');

    //send_command(cmd, appData.slaves_selected,parse_cmd_testing);

    mtest();

  });



  $('#testbutton4').on('click', function(e){

    let cmd = wget_rq("camogm_interface.php?cmd=run_status");
    send_command(cmd, appData.slaves_selected,parse_cmd_run_status);

  });

}

async function a_read_params(){

  let cmd = wget_rq("diagnostics.php");
  let targets = appData.slaves_selected;
  let result = await a_send_command(cmd,targets);
  return result;

}

async function a_detect_10393s(){

  let targets = appData.slaves_selected;
  let path = "/sys/devices/soc0/elphel393-detect_sensors@0";
  let cmd = [
      'cd '+path,
      'cat port_mux0',
      'cat sensor00',
      'cat sensor01',
      'cat sensor02',
      'cat sensor03',
      'cat port_mux1',
      'cat sensor10',
      'cat sensor11',
      'cat sensor12',
      'cat sensor13',
      'cat port_mux2',
      'cat sensor20',
      'cat sensor21',
      'cat sensor22',
      'cat sensor23',
      'cat port_mux3',
      'cat sensor30',
      'cat sensor31',
      'cat sensor32',
      'cat sensor33'
    ].join(';');

  let result = await a_send_command(cmd,targets);

  return result;

}

function detect_10393s(){

    let path = "/sys/devices/soc0/elphel393-detect_sensors@0";
    let cmd = [
      'cd '+path,
      'cat port_mux0',
      'cat sensor00',
      'cat sensor01',
      'cat sensor02',
      'cat sensor03',
      'cat port_mux1',
      'cat sensor10',
      'cat sensor11',
      'cat sensor12',
      'cat sensor13',
      'cat port_mux2',
      'cat sensor20',
      'cat sensor21',
      'cat sensor22',
      'cat sensor23',
      'cat port_mux3',
      'cat sensor30',
      'cat sensor31',
      'cat sensor32',
      'cat sensor33'
    ].join(';');

    send_command(cmd, appData.slaves_selected,parse_detect_10393s);

}

function wget_rq(cmd){
  return "wget -qO- -o /dev/null 'http://localhost/"+cmd+"'";
}

function parse_cmd_run_status(res){

  $(res).find('response').each(function(){

    const xmlstate = state_str2xml(this);
    console.log(xmlstate);

    if ($(xmlstate).find("state").text()==="off"){
      let cmd = wget_rq("camogm_interface.php?cmd=run_camogm");
      send_command(cmd, appData.slaves_selected);
    }

  });

}

function state_str2xml(res){
    let state = $(res).find('state').text();
    let xmlstate;
    try{
      xmlstate = $.parseXML(`${state}`);
    }
    catch(e){
      xmlstate = $.parseXML(`<document>${state}</document>`);
    }

    return xmlstate;
}

let refresh_hist_intvl;

//let parse_detect_10393s = parse_cmd_testing;

function parse_detect_10393s(res){

  parse_cmd_testing(res);
  // now read parameters

}

function parse_read_params(res){

  // reset init state
  //States.parsinit = false;

  $(res).find('response').each(function(){

    const name = $(this).find('node').text();
    let state = $(this).find('state').text();
    const x = state_str2xml(this);

    if ($(x).find("error").length!=0){
      $("tr."+name+" .slave_state").html("<b style='color:DarkOrange;'>not 10393</b>");
    }else{
      if ($(x).find("camera").length==1) {
        Cams.push(new E393(x));
      }
    }

  });

}

function parse_cmd_testing(res){

  $(res).find('response').each(function(){

    const name = $(this).find('node').text();
    let state = $(this).find('state').text();
    const xmlstate = state_str2xml(this);

    if ($(xmlstate).find("error").length!=0){
      console.log(name+" is not 10393");

      $("tr."+name+" .slave_state").html("<b style='color:DarkOrange;'>not 10393</b>");

      //$("."+name).append();
    }else{

      appData.nc10393[name] = {
        port:[
          {mux:"none",sensors:["none","none","none","none"]},
          {mux:"none",sensors:["none","none","none","none"]},
          {mux:"none",sensors:["none","none","none","none"]},
          {mux:"none",sensors:["none","none","none","none"]}
        ]
      };


      let sensors = state.trim().split('\n');
      //console.log(sensors);
      for(let i=0;i<4;i++){
        let mux = sensors[5*i];
        console.log("port "+i+" mux is "+mux);
        if (mux==="none"){
          console.log("sensor is "+sensors[5*i+1]);
          appData.nc10393[name].port[i].sensors[0] = sensors[5*i+1];
        }else{
          console.log("warning: mux is not 'none'");
        }
      }
    }

  });

  // now we can init histograms
  //init_histograms();
  //refresh_hist_intvl = setInterval(refresh_histograms,100);

}

function init_histograms(){

  for (let i in appData['slaves']){
    let sname = appData['slaves'][i];
    if (appData.nc10393[sname]===undefined){
      console.log(sname+" is not 10393");
    }else{

      // new row
      let newrow_id = "row_"+sname;
      $("#previews table").append("<tr><th colspan='4' align='left'>"+sname+":</th></tr>");
      $("#previews table").append("<tr id='"+newrow_id+"'></tr>");

      let ports = appData.nc10393[sname].port;

      for (j in ports) {

        // new col
        let newcol_id = "col_"+sname+"_"+j;
        $("#"+newrow_id).append("<td id='"+newcol_id+"'></td>");

        if (ports[j].sensors[0]!=="none") {
          // add histogram
          let ip = appData.ips[i];
          let ts = Date.now();
          let hst_src = 'http://'+ip+'/pnghist.cgi?sensor_port='+j+'&sqrt=1&scale=5&average=5&height=128&fillz=1&linterpz=0&draw=2&colors=41&_time='+ts;
          let img_src = 'http://'+ip+':'+(+j+2323)+'/img?_time='+ts;

          $("#"+newcol_id).append("<div>port "+j+"<div>");
          $("#"+newcol_id).append("<div><img class=\'hist_preview\' src=\'"+img_src+"\' /><div>");
          $("#"+newcol_id).append("<div><img class=\'hist_preview\' src=\'"+hst_src+"\' /><div>");

        }
      }
    }
  }

}

function refresh_histograms(){

  let ts = Date.now();

  $(".hist_preview").each(function(){

    let base = $(this).attr("src").slice(0,-13);
    $(this).attr("src",base+ts);

  });

}

function parse_cmd_state(res){

  $(res).find('response').each(function(){

    const name = $(this).find('node').text();
    const state = $(this).find('state').text();
    $("tr."+name+" .slave_state").html(state);

  });

}

function parse_cmd_ifconfig_init(res){

  $(res).find('response').each(function(){

    const name = $(this).find('node').text();
    const state = $(this).find('state').text();
    const ip = get_ipaddr_from_ifconfig(state);

    update_slave_list(name);
    update_ip_list(ip);
    //detect_10393s();

    /*
    let html = [
      '<div class=\''+name+'\'>',
      '<input class=\'slave_checkbox\' type=\'checkbox\' checked />',
      '<label class=\'slave_name\'>'+name+'</label>',
      '(<label class=\'slave_ip\'>'+ip+'</label>)',
      '</div>'
    ].join('\n');
    */
    //$("#slavenodes").append(html);

    let html = [
      '<tr class=\'slaverow '+name+'\'>',
      '  <td>',
      '    <input class=\'slave_checkbox\' type=\'checkbox\' checked />',
      '  </td>',
      '  <td>',
      '    <div class=\'slave_name\'>'+name+'</div>',
      '  </td>',
      '  <td>',
      '    <div class=\'slave_ip\'>'+ip+'</div>',
      '  </td>',
      '  <td>',
      '    <div class=\'slave_free_space\'>-</div>',
      '  </td>',
      '  <td>',
      '    <div class=\'slave_state\'>-</div>',
      '  </td>',
      '</tr>'
    ].join('\n');

    //console.log(html);

    $("#mstable .slave_table tbody").append(html);

  });

  $(".slave_checkbox").on("change",function(e){
    let checked = $(this).prop("checked");
    let name = $(this).parent().find("label").html();
    if (!checked) {
      appData.slaves_selected = appData.slaves_selected.filter(item => item!==name);
    }else{
      appData.slaves_selected.push(name);
    }
  });

}

function send_command(cmd,targets,callback){

    if (callback===undefined) {
      callback = function(res){
        console.log(res);
        //console.log($(res).find('document').html());
      }
    }

    let targets_str = "";
    if (Array.isArray(targets)){
      targets_str = targets.join(',');
    }else if (typeof targets === 'string' || targets instanceof String){
      targets_str = targets;
    }else{
      targets_str = "";
    }

    $.ajax({
      type: "POST",
      url: '/api/cmd',
      data: {
          master:  appData.master,
          targets: targets_str,
          cmd:     cmd
      },
      dataType: "xml",
      success: callback
    });

    return 0;
}

async function a_send_command(cmd,targets){

  let res;

  let targets_str = "";
  if (Array.isArray(targets)){
    targets_str = targets.join(',');
  }else if (typeof targets === 'string' || targets instanceof String){
    targets_str = targets;
  }else{
    targets_str = "";
  }

  try {
      res = await $.ajax({
        type: "POST",
        url: '/api/cmd',
        data: {
          master:  appData.master,
          targets: targets_str,
          cmd:     cmd
        },
        dataType: "xml"
      });
      return res;

  } catch (error) {
      console.error(error);
  }

}

function update_slave_list(name){
  appData.slaves.push(name);
  appData.slaves_selected.push(name);
}

function update_ip_list(ip){
  appData.ips.push(ip);
}

function update_master_node(newvalue){

  if (newvalue!==undefined){
    appData.master = newvalue;
    appData.slaves = [];
  }

  $("#masternode").html(appData.master);

}

function get_ipaddr_from_ifconfig(str){

  // for Elphel 10393
  const iface_regex_10393  = /[^\ \n]+(?=\ +Link\ encap)/gi;
  const ipaddr_regex_10393 = /(?<=inet\ addr\:)\d+\.\d+\.\d+\.\d+/gi;
  // for PC
  const iface_regex_pc     = /[^\ \n]+(?=\:\ flags)/gi;
  const ipaddr_regex_pc    = /(?<=inet\ )\d+\.\d+\.\d+\.\d+/gi;

  let res = "";

  let ifaces  = str.match(iface_regex_10393);
  let ipaddrs = str.match(ipaddr_regex_10393);

  if (ifaces===null || ipaddrs===null){
    ifaces  = str.match(iface_regex_pc);
    ipaddrs = str.match(ipaddr_regex_pc);
  }

  for(var i=0;i<ipaddrs.length;i++){

    if ((ifaces[i]!=='lo')&&(ifaces[i].search(/(eth|enp|wlp)/i)===0)) {
      res = ipaddrs[i];
      break;
    }

  }

  return res;

}

// url related functions
function parse_url(){

  let parameters=location.href.replace(/\?/ig,"&").split("&");
  for (let i=0;i<parameters.length;i++) parameters[i]=parameters[i].split("=");
  for (let i=1;i<parameters.length;i++) {
    switch (parameters[i][0]) {
      case "master":
        update_master_node(parameters[i][1]);
        send_command('ifconfig', appData.slaves, parse_cmd_ifconfig_init);
        break;
    }
  }

}

async function a_parse_url(){

  let res;

  let parameters=location.href.replace(/\?/ig,"&").split("&");
  for (let i=0;i<parameters.length;i++) parameters[i]=parameters[i].split("=");
  for (let i=1;i<parameters.length;i++) {
    switch (parameters[i][0]) {
      case "master":
        update_master_node(parameters[i][1]);
        //send_command('ifconfig', appData.slaves, parse_cmd_ifconfig_init);
        res = await a_send_command('ifconfig', appData.slaves);
        //parse_cmd_ifconfig_init(res);
        break;
    }
  }

  return res;

}

function rewrite_url(){

  let baseURL = "";

  if (location.href.lastIndexOf("?")==-1) {
    baseURL = location.href;
  }else{
    baseURL = location.href.substring(0,location.href.lastIndexOf("?"));
  }

  console.log(baseURL);

  const newURL = "?master="+appData.master;
  window.history.pushState('index.html', 'Title', baseURL+newURL);

}

function init_controls(){

  $("#rec_button").on("click",function(){
    States.recording = !States.recording;
    rec_button_switch(States.recording);
  });

}

function rec_button_switch(state){

  if (state){
    $("#rec_button").addClass("rec_outer_running");
    $("#rec_button .rec_inner").addClass("rec_inner_running");
  }else{
    $("#rec_button").removeClass("rec_outer_running");
    $("#rec_button .rec_inner").removeClass("rec_inner_running");
  }

}

function init_awb_toggle(){

  $('#toggle_awb').click(function() {

    if ($(this).find('.btn.active').html()=="ON"){
      wb_en = 0;
    }else{
      wb_en = 1;
    }

    button_switch($(this),wb_en);

    // will it work without port 0?
    //url = "parsedit.php?immediate&sensor_port=0&WB_EN="+wb_en+"&*WB_EN=0xf";
    //multi_ajax(url,function(res){
    //  console.log(this.ip+": awb "+wb_en);
    //});

  });

}

function init_aexp_toggle(){

  $('#toggle_aexp').click(function() {

    if ($(this).find('.btn.active').html()=="ON"){
      aexp_en = 0;
    }else{
      aexp_en = 1;
    }

    button_switch($(this),aexp_en);

    // will it work without port 0?
    //url = "parsedit.php?immediate&sensor_port=0&AUTOEXP_ON="+aexp_en+"&*AUTOEXP_ON=0xf";
    //multi_ajax(url,function(res){
    //  console.log(this.ip+": aexp "+aexp_en);
    //});

  });

}

// on or off
function button_switch(btn,state){

  //btn = $('#toggle_awb');

  if (state==1){
    if (btn.find('.btn.active').html()=="OFF"){
      btn.find('.btn.active').toggleClass('btn-danger');
      // toggle active
      btn.find('.btn').toggleClass('active');
      btn.find('.btn.active').toggleClass('btn-success');
      btn.find('.btn').toggleClass('btn-default');
    }
  }

  if (state==0){
    if (btn.find('.btn.active').html()=="ON"){
      btn.find('.btn.active').toggleClass('btn-success');
      // toggle active
      btn.find('.btn').toggleClass('active');
      btn.find('.btn.active').toggleClass('btn-danger');
      btn.find('.btn').toggleClass('btn-default');
    }
  }

}

// helper functions

function fps_period2fps(period){

  // the tick is 10ns, so:
  return (1e8/period).toFixed(2);

}

function format_str2num(str){

  let num;
  switch(str){
    case "jp4" : num = 5; break;
    case "jpeg": num = 0; break;
    default:     num = -1;
  }

  return num;
}

function format_num2str(num){

  let str;
  switch(num){
    case 0 : str = "jpeg"; break;
    case 5 : str = "jp4"; break;
    default: str = "unknown";
  }

  return str;
}
